var _interopRequireDefault=require("@babel/runtime/helpers/interopRequireDefault");Object.defineProperty(exports,"__esModule",{value:true});Object.defineProperty(exports,"logWelcome",{enumerable:true,get:function get(){return _logger.logWelcome;}});Object.defineProperty(exports,"logError",{enumerable:true,get:function get(){return _logger.logError;}});Object.defineProperty(exports,"logTask",{enumerable:true,get:function get(){return _logger.logTask;}});Object.defineProperty(exports,"logWarning",{enumerable:true,get:function get(){return _logger.logWarning;}});Object.defineProperty(exports,"logDebug",{enumerable:true,get:function get(){return _logger.logDebug;}});Object.defineProperty(exports,"logInfo",{enumerable:true,get:function get(){return _logger.logInfo;}});Object.defineProperty(exports,"logComplete",{enumerable:true,get:function get(){return _logger.logComplete;}});Object.defineProperty(exports,"logSuccess",{enumerable:true,get:function get(){return _logger.logSuccess;}});Object.defineProperty(exports,"logEnd",{enumerable:true,get:function get(){return _logger.logEnd;}});Object.defineProperty(exports,"configureRnvGlobal",{enumerable:true,get:function get(){return _configParser.configureRnvGlobal;}});Object.defineProperty(exports,"askQuestion",{enumerable:true,get:function get(){return _prompt.askQuestion;}});Object.defineProperty(exports,"generateOptions",{enumerable:true,get:function get(){return _prompt.generateOptions;}});Object.defineProperty(exports,"finishQuestion",{enumerable:true,get:function get(){return _prompt.finishQuestion;}});exports.default=exports.resolveNodeModulePath=exports.checkPortInUse=exports.cleanPlatformIfRequired=exports.getIP=exports.getConfigProp=exports.getAppLicense=exports.getAppAuthor=exports.getAppDescription=exports.getAppConfigId=exports.getGetJsBundleFile=exports.getEntryFile=exports.copyBuildsFolder=exports.writeCleanFile=exports.getAppVersionCode=exports.getAppVersion=exports.getAppTitle=exports.getAppId=exports.configureIfRequired=exports.checkSdk=exports.isSdkInstalled=exports.isPlatformActive=exports.logErrorPlatform=exports.startBuilder=exports.initializeBuilder=exports.getAppTemplateFolder=exports.getAppFolder=exports.isPlatformSupportedSync=exports.isBuildSchemeSupported=exports.cleanNodeModules=exports.isPlatformSupported=exports.getBuildsFolder=exports.configureEntryPoints=exports.getBuildFilePath=exports.spawnCommand=void 0;var _extends2=_interopRequireDefault(require("@babel/runtime/helpers/extends"));var _defineProperty2=_interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _chalk=_interopRequireDefault(require("chalk"));
var _fs=_interopRequireDefault(require("fs"));
var _path=_interopRequireDefault(require("path"));
var _detectPort=_interopRequireDefault(require("detect-port"));
var _child_process=require("child_process");

var _fileutils=require("./systemTools/fileutils");




var _platform=require("./cli/platform");
var _app=_interopRequireDefault(require("./cli/app"));
var _tizen=require("./platformTools/tizen");
var _templateTools=require("./templateTools");
var _pluginTools=require("./pluginTools");
var _logger=require("./systemTools/logger");




var _constants=require("./constants");









var _exec=require("./systemTools/exec");
var _configParser=require("./configTools/configParser");



var _prompt=require("./systemTools/prompt");function ownKeys(object,enumerableOnly){var keys=Object.keys(object);if(Object.getOwnPropertySymbols){var symbols=Object.getOwnPropertySymbols(object);if(enumerableOnly)symbols=symbols.filter(function(sym){return Object.getOwnPropertyDescriptor(object,sym).enumerable;});keys.push.apply(keys,symbols);}return keys;}function _objectSpread(target){for(var i=1;i<arguments.length;i++){var source=arguments[i]!=null?arguments[i]:{};if(i%2){ownKeys(source,true).forEach(function(key){(0,_defineProperty2.default)(target,key,source[key]);});}else if(Object.getOwnPropertyDescriptors){Object.defineProperties(target,Object.getOwnPropertyDescriptors(source));}else{ownKeys(source).forEach(function(key){Object.defineProperty(target,key,Object.getOwnPropertyDescriptor(source,key));});}}return target;}

var NO_OP_COMMANDS=['fix','clean','tool','status','crypto'];


var isPlatformSupportedSync=function isPlatformSupportedSync(platform,resolve,reject){
if(!platform){
if(reject){
reject(
_chalk.default.red("You didn't specify platform. make sure you add \""+
_chalk.default.white.bold(
'-p <PLATFORM>')+"\" option to your command!"));



}
return false;
}
if(!_constants.SUPPORTED_PLATFORMS.includes(platform)){
if(reject)reject(_chalk.default.red("Platform "+platform+" is not supported"));
return false;
}
if(resolve)resolve();
return true;
};exports.isPlatformSupportedSync=isPlatformSupportedSync;

var isPlatformSupported=function isPlatformSupported(c){return new Promise(function(resolve,reject){
(0,_logger.logTask)("isPlatformSupported:"+c.platform);
if(!c.platform||c.platform==='?'){
var platformsAsObj=c.buildConfig?c.buildConfig.platforms:c.supportedPlatforms;
if(!platformsAsObj)platformsAsObj=_constants.SUPPORTED_PLATFORMS;
var opts=(0,_prompt.generateOptions)(platformsAsObj);

(0,_prompt.askQuestion)("Pick one of available platforms (number or text):\n"+opts.asString).then(function(v){
(0,_prompt.finishQuestion)();

opts.pick(v).
then(function(selectedPlatform){
c.platform=selectedPlatform;
c.program.platform=selectedPlatform;
resolve(selectedPlatform);
}).
catch(function(e){return reject(e);});
});
}else if(!_constants.SUPPORTED_PLATFORMS.includes(c.platform)){
reject(_chalk.default.red("Platform "+c.platform+" is not supported"));
}else{
resolve();
}
});};exports.isPlatformSupported=isPlatformSupported;

var isBuildSchemeSupported=function isBuildSchemeSupported(c){return new Promise(function(resolve,reject){
(0,_logger.logTask)("isBuildSchemeSupported:"+c.platform);var

scheme=c.program.scheme;

if(!c.buildConfig.platforms[c.platform]){
c.buildConfig.platforms[c.platform]={};
}var

buildSchemes=c.buildConfig.platforms[c.platform].buildSchemes;


if(!buildSchemes){
(0,_logger.logWarning)("Your appConfig for platform "+c.platform+" has no buildSchemes. Will continue with defaults");
resolve();
return;
}

var schemeDoesNotExist=scheme&&!buildSchemes[scheme];
if(scheme==='?'||schemeDoesNotExist){
if(schemeDoesNotExist&&scheme&&scheme!=='?'){
(0,_logger.logError)('Build scheme you picked does not exists.');
}
var opts=(0,_prompt.generateOptions)(buildSchemes);

(0,_prompt.askQuestion)("Pick one of available buildSchemes (number or text):\n"+opts.asString).then(function(v){
(0,_prompt.finishQuestion)();
opts.pick(v).
then(function(selectedScheme){
c.program.scheme=selectedScheme;
resolve(selectedScheme);
}).catch(function(e){return reject(e);});
});
}else{
resolve(scheme);
}
});};exports.isBuildSchemeSupported=isBuildSchemeSupported;

var initializeBuilder=function initializeBuilder(cmd,subCmd,process,program){return new Promise(function(resolve,reject){
var c=(0,_configParser.createRnvConfig)(program,process,cmd,subCmd);

(0,_logger.configureLogger)(c,c.process,c.command,c.subCommand,program.info===true);
(0,_logger.logInitialize)();

resolve(c);
});};exports.initializeBuilder=initializeBuilder;

var startBuilder=function startBuilder(c){return new Promise(function(resolve,reject){
(0,_logger.logTask)('initializeBuilder');

c.files.pluginTemplatesConfig=JSON.parse(_fs.default.readFileSync(_path.default.join(c.paths.rnv.pluginTemplates.config)).toString());

if(c.command==='app'&&c.subCommand==='create'||c.command==='new'){
resolve(c);
return;
}

(0,_configParser.parseRenativeConfigsSync)(c);

if(c.command==='target'||c.command==='log'||c.subCommand==='fixPackage'){
(0,_configParser.configureRnvGlobal)(c).
then(function(){return resolve(c);}).
catch(function(e){return reject(e);});
return;
}

if(!c.paths.project.configExists){
reject("Looks like this directory is not ReNative project. Project config "+
_chalk.default.white(
c.paths.project.config)+" is missing!. You can create new project with "+
_chalk.default.white('rnv new'));

}

if(c.command==='platform'){
(0,_configParser.configureRnvGlobal)(c).
then(function(){return resolve(c);}).
catch(function(e){return reject(e);});
return;
}

if(NO_OP_COMMANDS.includes(c.command)){
(0,_configParser.gatherInfo)(c).
then(function(){return resolve(c);}).
catch(function(e){return reject(c);});
return;
}

(0,_configParser.configureRnvGlobal)(c).
then(function(){return(0,_templateTools.checkIfTemplateInstalled)(c);}).
then(function(){return(0,_configParser.fixRenativeConfigsSync)(c);}).
then(function(){return configureNodeModules(c);}).
then(function(){return(0,_templateTools.applyTemplate)(c);}).
then(function(){return configurePlugins(c);}).
then(function(){return configureNodeModules(c);}).
then(function(){return configureApp(c);}).
then(function(){return(0,_logger.logAppInfo)(c);}).
then(function(){return resolve(c);}).
catch(function(e){return reject(e);});
});};exports.startBuilder=startBuilder;

var configureNodeModules=function configureNodeModules(c){return new Promise(function(resolve,reject){
(0,_logger.logTask)('configureNodeModules');

if(!_fs.default.existsSync(c.paths.project.nodeModulesDir)||c._requiresNpmInstall){
if(!_fs.default.existsSync(c.paths.project.nodeModulesDir)){
(0,_logger.logWarning)("Looks like your node_modules folder "+
_chalk.default.white(c.paths.project.nodeModulesDir)+" is missing! Let's run "+_chalk.default.white(
'npm install')+" first!");


}else{
(0,_logger.logWarning)("Looks like your node_modules out of date! Let's run "+_chalk.default.white('npm install')+" first!");
}
_npmInstall(c).then(function(){return resolve();}).catch(function(e){return reject(e);});
}else{
resolve();
}
});};

var _npmInstall=function _npmInstall(c){var failOnError=arguments.length>1&&arguments[1]!==undefined?arguments[1]:false;return new Promise(function(resolve,reject){
(0,_logger.logTask)('_npmInstall');
(0,_exec.executeAsync)('npm',['install']).
then(function(){
resolve();
}).
catch(function(e){
if(failOnError){
(0,_logger.logError)(e);
resolve();
}else{
(0,_logger.logWarning)(e+"\n Seems like your node_modules is corrupted by other libs. ReNative will try to fix it for you");
cleanNodeModules(c).
then(function(){return _npmInstall(c,true);}).
then(function(){return resolve();}).
catch(function(e){
(0,_logger.logError)(e);
resolve();
});
}
});
});};

var cleanNodeModules=function cleanNodeModules(c){return new Promise(function(resolve,reject){
(0,_logger.logTask)("cleanNodeModules:"+c.paths.project.nodeModulesDir);
(0,_fileutils.removeDirs)([
_path.default.join(c.paths.project.nodeModulesDir,'react-native-safe-area-view/.git'),
_path.default.join(c.paths.project.nodeModulesDir,'@react-navigation/native/node_modules/react-native-safe-area-view/.git'),
_path.default.join(c.paths.project.nodeModulesDir,'react-navigation/node_modules/react-native-safe-area-view/.git'),
_path.default.join(c.paths.rnv.nodeModulesDir,'react-native-safe-area-view/.git'),
_path.default.join(c.paths.rnv.nodeModulesDir,'@react-navigation/native/node_modules/react-native-safe-area-view/.git'),
_path.default.join(c.paths.rnv.nodeModulesDir,'react-navigation/node_modules/react-native-safe-area-view/.git')]).
then(function(){return resolve();}).catch(function(e){return reject(e);});
});};exports.cleanNodeModules=cleanNodeModules;


var configureEntryPoints=function configureEntryPoints(c){
(0,_logger.logTask)('configureEntryPoints');







var plat;
var p=c.buildConfig.platforms;
for(var k in p){
plat=p[k];
var source=_path.default.join(c.paths.projectTemplateFolder,plat.entryFile+".js");
var backupSource=_path.default.join(c.paths.rnv.projectTemplate.dir,'entry',plat.entryFile+".js");
var dest=_path.default.join(c.paths.project.dir,plat.entryFile+".js");
if(!_fs.default.existsSync(dest)){
if(!plat.entryFile){
(0,_logger.logError)("You missing entryFile for "+_chalk.default.white(k)+" platform in your "+_chalk.default.white(c.paths.appConfig.config)+".");
}else if(!_fs.default.existsSync(source)){
(0,_logger.logWarning)("You missing entry file "+_chalk.default.white(source)+" in your template. ReNative Will use default backup entry from "+_chalk.default.white(backupSource)+"!");
(0,_fileutils.copyFileSync)(backupSource,dest);
}else{
(0,_logger.logWarning)("You missing entry file "+_chalk.default.white(plat.entryFile)+" in your project. let's create one for you!");
(0,_fileutils.copyFileSync)(source,dest);
}
}
}
};exports.configureEntryPoints=configureEntryPoints;

var configurePlugins=function configurePlugins(c){return new Promise(function(resolve,reject){
if(!c.files.project.package.dependencies){
c.files.project.package.dependencies={};
}

var hasPackageChanged=false;
for(var k in c.buildConfig.plugins){
var dependencies=c.files.project.package.dependencies;
var devDependencies=c.files.project.package.devDependencies;
var plugin=(0,_pluginTools.getMergedPlugin)(c,k,c.buildConfig.plugins);

if(!plugin){
(0,_logger.logWarning)("Plugin with name "+
_chalk.default.white(k)+" does not exists in ReNative source:rnv scope. you need to define it manually here: "+
_chalk.default.white(c.paths.project.builds.config));
}else if(dependencies&&dependencies[k]){
if(plugin['no-active']!==true&&plugin['no-npm']!==true&&dependencies[k]!==plugin.version){
if(k==='renative'&&c.runtime.isWrapper){
(0,_logger.logWarning)('You\'re in ReNative wrapper mode. plugin renative will stay as local dep!');
}else{
(0,_logger.logWarning)("Version mismatch of dependency "+
_chalk.default.white(k)+" between:\n  "+
_chalk.default.white(c.paths.project.package)+": v("+_chalk.default.red(dependencies[k])+") and\n  "+
_chalk.default.white(c.paths.project.builds.config)+": v("+_chalk.default.green(plugin.version)+").\n  package.json will be overriden");


hasPackageChanged=true;
dependencies[k]=plugin.version;
}
}
}else if(devDependencies&&devDependencies[k]){
if(plugin['no-active']!==true&&plugin['no-npm']!==true&&devDependencies[k]!==plugin.version){
(0,_logger.logWarning)("Version mismatch of devDependency "+
_chalk.default.white(k)+" between package.json: v("+_chalk.default.red(
devDependencies[k])+") and plugins.json: v("+
_chalk.default.red(plugin.version)+"). package.json will be overriden");

hasPackageChanged=true;
devDependencies[k]=plugin.version;
}
}else if(plugin['no-active']!==true&&plugin['no-npm']!==true){

(0,_logger.logWarning)("Missing dependency "+
_chalk.default.white(k)+" v("+_chalk.default.red(
plugin.version)+") in package.json. package.json will be overriden");



hasPackageChanged=true;
dependencies[k]=plugin.version;
}

if(plugin&&plugin.npm){
for(var npmKey in plugin.npm){
var npmDep=plugin.npm[npmKey];
if(dependencies[npmKey]!==npmDep){
(0,_logger.logWarning)("Plugin "+_chalk.default.white(k)+" requires npm dependency "+_chalk.default.white(npmKey)+" .Adding missing npm dependency to you package.json");
dependencies[npmKey]=npmDep;
hasPackageChanged=true;
}
}
}
}
if(hasPackageChanged){
(0,_fileutils.writeObjectSync)(c.paths.project.package,c.files.project.package);
c._requiresNpmInstall=true;
}

resolve();
});};

var configureApp=function configureApp(c){return new Promise(function(resolve,reject){
(0,_logger.logTask)("configureApp:"+c.runtime.appId);

if(c.runtime.appId){

(0,_configParser.updateConfig)(c,c.runtime.appId).
then(function(){
configureEntryPoints(c);
resolve(c);
}).
catch(function(e){return reject(e);});
}else{

if(!_fs.default.existsSync(c.paths.project.builds.config)){
(0,_logger.logWarning)("Seems like you're missing "+

c.paths.project.builds.config+" file. But don't worry. ReNative got you covered. Let's configure it for you!");



(0,_configParser.updateConfig)(c,c.defaultAppConfigId).
then(function(){
configureEntryPoints(c);
(0,_app.default)(spawnCommand(c,{
command:'configure',
program:{
appConfig:c.defaultAppConfigId,
update:true}})).


then(function(){return resolve(c);}).
catch(function(e){return reject(e);});
}).
catch(function(e){return reject(e);});
}else{
try{
var assetConfig=JSON.parse(_fs.default.readFileSync(c.paths.project.builds.config).toString());
(0,_configParser.updateConfig)(c,assetConfig.id).
then(function(){
configureEntryPoints(c);
resolve(c);
}).
catch(function(e){return reject(e);});
}catch(e){
reject(e);
}
}
}
});};

var spawnCommand=function spawnCommand(c,overrideParams){
var newCommand={};

Object.keys(c).forEach(function(k){
if(typeof newCommand[k]==='object'&&!(newCommand[k]instanceof'String')){
newCommand[k]=_objectSpread({},c[k]);
}else{
newCommand[k]=c[k];
}
});

var merge=require('deepmerge');

Object.keys(overrideParams).forEach(function(k){
if(newCommand[k]&&typeof overrideParams[k]==='object'){
newCommand[k]=merge(newCommand[k],overrideParams[k],{arrayMerge:_arrayMergeOverride});
}else{
newCommand[k]=overrideParams[k];
}
});




return newCommand;
};exports.spawnCommand=spawnCommand;

var isSdkInstalled=function isSdkInstalled(c,platform){
(0,_logger.logTask)("isSdkInstalled: "+platform);

if(c.files.globalConfig){
var sdkPlatform=_constants.SDK_PLATFORMS[platform];
if(sdkPlatform)return _fs.default.existsSync(c.files.globalConfig.sdks[sdkPlatform]);
}

return false;
};exports.isSdkInstalled=isSdkInstalled;

var checkSdk=function checkSdk(c,platform,reject){
if(!isSdkInstalled(c,platform)){
reject&&reject(platform+" requires SDK to be installed. check your "+c.paths.private.config+" file if you SDK path is correct");
return false;
}
return true;
};exports.checkSdk=checkSdk;

var _arrayMergeOverride=function _arrayMergeOverride(destinationArray,sourceArray,mergeOptions){return sourceArray;};

var getAppFolder=function getAppFolder(c,platform){return _path.default.join(c.paths.project.builds.dir,c.runtime.appId+"_"+platform);};exports.getAppFolder=getAppFolder;

var getAppTemplateFolder=function getAppTemplateFolder(c,platform){return _path.default.join(c.paths.project.platformTemplatesDirs[platform],""+platform);};exports.getAppTemplateFolder=getAppTemplateFolder;

var getAppConfigId=function getAppConfigId(c,platform){return c.buildConfig.id;};exports.getAppConfigId=getAppConfigId;

var _getValueOrMergedObject=function _getValueOrMergedObject(resultCli,o1,o2,o3){
if(resultCli){
return resultCli;
}
if(o1){
if(Array.isArray(o1)||typeof o1!=='object')return o1;
var val=(0,_extends2.default)(o3||{},o2||{},o1);
return val;
}
if(o2){
if(Array.isArray(o2)||typeof o2!=='object')return o2;
return(0,_extends2.default)(o3||{},o2);
}
return o3;
};

var CLI_PROPS=[
'provisioningStyle',
'codeSignIdentity',
'provisionProfileSpecifier'];


var getConfigProp=function getConfigProp(c,platform,key,defaultVal){
if(!c.buildConfig){
(0,_logger.logError)('getConfigProp: c.buildConfig is undefined!');
return null;
}
var p=c.buildConfig.platforms[platform];
var ps=_getScheme(c);
var resultPlatforms;
var scheme;
if(p){
scheme=p.buildSchemes?p.buildSchemes[ps]:null;
resultPlatforms=c.buildConfig.platforms[platform][key];
}


scheme=scheme||{};
var resultCli=CLI_PROPS.includes(key)?c.program[key]:null;
var resultScheme=scheme[key];
var resultCommon=c.buildConfig.common[key];

var result=_getValueOrMergedObject(resultCli,resultScheme,resultPlatforms,resultCommon);

(0,_logger.logTask)("getConfigProp:"+platform+":"+key+":"+result,_chalk.default.grey);
if(result===null||result===undefined)return defaultVal;
return result;
};exports.getConfigProp=getConfigProp;

var getJsBundleFileDefaults={
android:'super.getJSBundleFile()',
androidtv:'super.getJSBundleFile()',

androidwear:'"assets://index.androidwear.bundle"'};


var getAppId=function getAppId(c,platform){return getConfigProp(c,platform,'id');};exports.getAppId=getAppId;

var getAppTitle=function getAppTitle(c,platform){return getConfigProp(c,platform,'title');};exports.getAppTitle=getAppTitle;

var getAppVersion=function getAppVersion(c,platform){return c.buildConfig.platforms[platform].version||c.buildConfig.common.verion||c.files.project.package.version;};exports.getAppVersion=getAppVersion;

var getAppAuthor=function getAppAuthor(c,platform){return c.buildConfig.platforms[platform].author||c.buildConfig.common.author||c.files.project.package.author;};exports.getAppAuthor=getAppAuthor;

var getAppLicense=function getAppLicense(c,platform){return c.buildConfig.platforms[platform].license||c.buildConfig.common.license||c.files.project.package.license;};exports.getAppLicense=getAppLicense;

var getEntryFile=function getEntryFile(c,platform){return c.buildConfig.platforms[platform].entryFile;};exports.getEntryFile=getEntryFile;

var getGetJsBundleFile=function getGetJsBundleFile(c,platform){return c.buildConfig.platforms[platform].getJsBundleFile||getJsBundleFileDefaults[platform];};exports.getGetJsBundleFile=getGetJsBundleFile;

var getAppDescription=function getAppDescription(c,platform){return c.buildConfig.platforms[platform].description||c.buildConfig.common.description||c.files.project.package.description;};exports.getAppDescription=getAppDescription;

var getAppVersionCode=function getAppVersionCode(c,platform){
if(c.buildConfig.platforms[platform].versionCode){
return c.buildConfig.platforms[platform].versionCode;
}
if(c.buildConfig.common.verionCode){
return c.buildConfig.common.verionCode;
}
var version=getAppVersion(c,platform);

var vc='';
version.
split('-')[0].
split('.').
forEach(function(v){
vc+=v.length>1?v:"0"+v;
});
return Number(vc).toString();
};exports.getAppVersionCode=getAppVersionCode;

var logErrorPlatform=function logErrorPlatform(platform,resolve){
(0,_logger.logError)("Platform: "+_chalk.default.white(platform)+" doesn't support command: "+_chalk.default.white(c.command));
resolve&&resolve();
};exports.logErrorPlatform=logErrorPlatform;

var isPlatformActive=function isPlatformActive(c,platform,resolve){
if(!c.buildConfig||!c.buildConfig.platforms){
(0,_logger.logError)("Looks like your appConfigFile is not configured properly! check "+_chalk.default.white(c.paths.appConfig.config)+" location.");
if(resolve)resolve();
return false;
}
if(!c.buildConfig.platforms[platform]){
console.log("Platform "+platform+" not configured for "+c.runtime.appId+". skipping.");
if(resolve)resolve();
return false;
}
return true;
};exports.isPlatformActive=isPlatformActive;

var PLATFORM_RUNS={};

var configureIfRequired=function configureIfRequired(c,platform){return new Promise(function(resolve,reject){
(0,_logger.logTask)("_configureIfRequired:"+platform);

if(PLATFORM_RUNS[platform]){
resolve();
return;
}
PLATFORM_RUNS[platform]=true;var
device=c.program.device;


var nc=spawnCommand(c,{
command:'configure',
program:{
appConfig:c.id,
update:false,
platform:platform,
device:device}});



if(c.program.reset){
(0,_platform.cleanPlatformBuild)(c,platform).
then(function(){return(0,_platform.createPlatformBuild)(c,platform);}).
then(function(){return(0,_app.default)(nc);}).
then(function(){return resolve(c);}).
catch(function(e){return reject(e);});
}else{
(0,_platform.createPlatformBuild)(c,platform).
then(function(){return(0,_app.default)(nc);}).
then(function(){return resolve(c);}).
catch(function(e){return reject(e);});
}
});};exports.configureIfRequired=configureIfRequired;

var writeCleanFile=function writeCleanFile(source,destination,overrides){

if(!_fs.default.existsSync(source)){
(0,_logger.logError)("Cannot write file. source path doesn't exists: "+source);
return;
}
if(!_fs.default.existsSync(destination)){
(0,_logger.logWarning)("destination path doesn't exists: "+destination+". will create new one");

}
var pFile=_fs.default.readFileSync(source,'utf8');
var pFileClean=pFile;
overrides.forEach(function(v){
var regEx=new RegExp(v.pattern,'g');
pFileClean=pFileClean.replace(regEx,v.override);
});

_fs.default.writeFileSync(destination,pFileClean,'utf8');
};exports.writeCleanFile=writeCleanFile;

var copyBuildsFolder=function copyBuildsFolder(c,platform){return new Promise(function(resolve,reject){
(0,_logger.logTask)("copyBuildsFolder:"+platform);
if(!isPlatformActive(c,platform,resolve))return;

var destPath=_path.default.join(getAppFolder(c,platform));


var sourcePath1=getBuildsFolder(c,platform,c.paths.project.projectConfig.dir);
(0,_fileutils.copyFolderContentsRecursiveSync)(sourcePath1,destPath);


var sourcePath1sec=getBuildsFolder(c,platform,c.paths.private.project.projectConfig.dir);
(0,_fileutils.copyFolderContentsRecursiveSync)(sourcePath1sec,destPath);


var sourcePath0=getBuildsFolder(c,platform,c.paths.appConfig.dir);
(0,_fileutils.copyFolderContentsRecursiveSync)(sourcePath0,destPath,c.paths.appConfig.dir);


var sourcePath0sec=getBuildsFolder(c,platform,c.paths.private.appConfig.dir);
(0,_fileutils.copyFolderContentsRecursiveSync)(sourcePath0sec,destPath);

(0,_pluginTools.parsePlugins)(c,platform,function(plugin,pluginPlat,key){

var sourcePath3=getBuildsFolder(c,platform,_path.default.join(c.paths.project.projectConfig.dir,"plugins/"+key));
(0,_fileutils.copyFolderContentsRecursiveSync)(sourcePath3,destPath);


var sourcePath3sec=getBuildsFolder(c,platform,_path.default.join(c.paths.private.project.projectConfig.dir,"plugins/"+key));
(0,_fileutils.copyFolderContentsRecursiveSync)(sourcePath3sec,destPath);


var sourcePath2=getBuildsFolder(c,platform,_path.default.join(c.paths.appConfig.dir,"plugins/"+key));
(0,_fileutils.copyFolderContentsRecursiveSync)(sourcePath2,destPath);


var sourcePath2sec=getBuildsFolder(c,platform,_path.default.join(c.paths.private.appConfig.dir,"plugins/"+key));
(0,_fileutils.copyFolderContentsRecursiveSync)(sourcePath2sec,destPath);
});

resolve();
});};exports.copyBuildsFolder=copyBuildsFolder;

var _getScheme=function _getScheme(c){return c.program.scheme||'debug';};

var getBuildsFolder=function getBuildsFolder(c,platform,customPath){
var pp=customPath||c.paths.appConfig.dir;



var p=_path.default.join(pp,"builds/"+platform+"@"+_getScheme(c));
if(_fs.default.existsSync(p))return p;
return _path.default.join(pp,"builds/"+platform);
};exports.getBuildsFolder=getBuildsFolder;

var getIP=function getIP(){
var ip=require('ip');
return ip.address();
};exports.getIP=getIP;

var cleanPlatformIfRequired=function cleanPlatformIfRequired(c,platform){return new Promise(function(resolve,reject){
if(c.program.reset){
(0,_logger.logInfo)("You passed "+_chalk.default.white('-r')+" argument. paltform "+_chalk.default.white(platform)+" will be cleaned up first!");
(0,_platform.cleanPlatformBuild)(c,platform).
then(function(){return resolve(c);}).
catch(function(e){return reject(e);});
}else{
resolve();
}
});};exports.cleanPlatformIfRequired=cleanPlatformIfRequired;

var checkPortInUse=function checkPortInUse(c,platform,port){return new Promise(function(resolve,reject){
(0,_detectPort.default)(port,function(err,availablePort){
if(err){
reject(err);
return;
}
resolve(port!==availablePort);
});
});};exports.checkPortInUse=checkPortInUse;

var resolveNodeModulePath=function resolveNodeModulePath(c,filePath){
var pth=_path.default.join(c.paths.rnv.nodeModulesDir,filePath);
if(!_fs.default.existsSync(pth)){
pth=_path.default.join(c.paths.project.nodeModulesDir,filePath);
}
return pth;
};exports.resolveNodeModulePath=resolveNodeModulePath;

var getBuildFilePath=function getBuildFilePath(c,platform,filePath){

var sp=_path.default.join(getAppTemplateFolder(c,platform),filePath);

var sp2=_path.default.join(getBuildsFolder(c,platform,c.paths.project.projectConfig.dir),filePath);
if(_fs.default.existsSync(sp2))sp=sp2;

var sp3=_path.default.join(getBuildsFolder(c,platform),filePath);
if(_fs.default.existsSync(sp3))sp=sp3;
return sp;
};exports.getBuildFilePath=getBuildFilePath;var _default=


















































{
getBuildFilePath:getBuildFilePath,
getBuildsFolder:getBuildsFolder,
configureEntryPoints:configureEntryPoints,
generateOptions:_prompt.generateOptions,
logWelcome:_logger.logWelcome,
copyBuildsFolder:copyBuildsFolder,
cleanNodeModules:cleanNodeModules,
isPlatformSupported:isPlatformSupported,
isBuildSchemeSupported:isBuildSchemeSupported,
isPlatformSupportedSync:isPlatformSupportedSync,
getAppFolder:getAppFolder,
getAppTemplateFolder:getAppTemplateFolder,
logTask:_logger.logTask,
logComplete:_logger.logComplete,
logError:_logger.logError,
initializeBuilder:initializeBuilder,
startBuilder:startBuilder,
logDebug:_logger.logDebug,
logInfo:_logger.logInfo,
logErrorPlatform:logErrorPlatform,
isPlatformActive:isPlatformActive,
isSdkInstalled:isSdkInstalled,
checkSdk:checkSdk,
logEnd:_logger.logEnd,
logWarning:_logger.logWarning,
configureIfRequired:configureIfRequired,
getAppId:getAppId,
getAppTitle:getAppTitle,
getAppVersion:getAppVersion,
getAppVersionCode:getAppVersionCode,
writeCleanFile:writeCleanFile,
getEntryFile:getEntryFile,
getGetJsBundleFile:getGetJsBundleFile,
getAppConfigId:getAppConfigId,
getAppDescription:getAppDescription,
getAppAuthor:getAppAuthor,
getAppLicense:getAppLicense,
logSuccess:_logger.logSuccess,
getConfigProp:getConfigProp,
getIP:getIP,
cleanPlatformIfRequired:cleanPlatformIfRequired,
checkPortInUse:checkPortInUse,
finishQuestion:_prompt.finishQuestion,
askQuestion:_prompt.askQuestion,
resolveNodeModulePath:resolveNodeModulePath,
configureRnvGlobal:_configParser.configureRnvGlobal};exports.default=_default;