var _interopRequireDefault=require("@babel/runtime/helpers/interopRequireDefault");Object.defineProperty(exports,"__esModule",{value:true});exports.copySharedPlatforms=exports.copyRuntimeAssets=exports.checkAndCreateGitignore=exports.checkAndCreateProjectConfig=exports.checkAndCreateProjectPackage=void 0;var _path=_interopRequireDefault(require("path"));
var _fs=_interopRequireDefault(require("fs"));
var _chalk=_interopRequireDefault(require("chalk"));
var _deepmerge=_interopRequireDefault(require("deepmerge"));
var _constants=require("../constants");















































var _fileutils=require("../systemTools/fileutils");




var _logger=require("../systemTools/logger");




var _prompt=require("../systemTools/prompt");


var checkAndCreateProjectPackage=function checkAndCreateProjectPackage(c,data){
(0,_logger.logTask)("checkAndCreateProjectPackage:"+data.packageName);var

packageName=
data.packageName,appTitle=data.appTitle,appID=data.appID,supportedPlatforms=data.supportedPlatforms;

if(!_fs.default.existsSync(c.paths.project.package)){
(0,_logger.logInfo)("Looks like your package.json is missing. Let's create one for you!");

var pkgJson={};
pkgJson.name=packageName;
pkgJson.title=appTitle;
pkgJson.version=data.version;
pkgJson.dependencies={
renative:'latest'};

pkgJson.devDependencies={
rnv:c.files.rnv.package.version};

pkgJson.devDependencies[data.optionTemplates.selectedOption]='latest';

var pkgJsonStringClean=JSON.stringify(pkgJson,null,2);

_fs.default.writeFileSync(c.paths.project.package,pkgJsonStringClean);
}
};exports.checkAndCreateProjectPackage=checkAndCreateProjectPackage;

var checkAndCreateProjectConfig=function checkAndCreateProjectConfig(c,data){
(0,_logger.logTask)('checkAndCreateProjectConfig');var

packageName=
data.packageName,appTitle=data.appTitle,appID=data.appID,supportedPlatforms=data.supportedPlatforms;

if(!_fs.default.existsSync(c.paths.project.config)){
(0,_logger.logInfo)("You're missing "+_constants.RENATIVE_CONFIG_NAME+" file in your root project! Let's create one!");

var defaultProjectConfigs={
supportedPlatforms:data.optionPlatforms.selectedOptions,
template:data.optionTemplates.selectedOption,
defaultAppId:appID.toLowerCase()};


var obj=JSON.parse(_fs.default.readFileSync(_path.default.join(c.paths.rnv.projectTemplate.dir,_constants.RENATIVE_CONFIG_TEMPLATE_NAME)));

obj.defaults=defaultProjectConfigs;

(0,_fileutils.writeObjectSync)(_path.default.join(c.paths.project.dir,_constants.RENATIVE_CONFIG_NAME),obj);
}
};exports.checkAndCreateProjectConfig=checkAndCreateProjectConfig;

var checkAndCreateGitignore=function checkAndCreateGitignore(c){
(0,_logger.logTask)('checkAndCreateGitignore');
var ignrPath=_path.default.join(c.paths.project.dir,'.gitignore');
if(!_fs.default.existsSync(ignrPath)){
(0,_logger.logInfo)("Looks like your .gitignore is missing. Let's create one for you!");

(0,_fileutils.copyFileSync)(_path.default.join(c.paths.rnv.dir,'supportFiles/gitignore-template'),ignrPath);
}
};exports.checkAndCreateGitignore=checkAndCreateGitignore;

var copyRuntimeAssets=function copyRuntimeAssets(c){return new Promise(function(resolve,reject){
(0,_logger.logTask)('copyRuntimeAssets');
var aPath=_path.default.join(c.paths.project.assets.dir,'runtime');
var cPath=_path.default.join(c.paths.appConfig.dir,'assets/runtime');
(0,_fileutils.copyFolderContentsRecursiveSync)(cPath,aPath);


_fs.default.writeFileSync(_path.default.join(c.paths.project.assets.dir,_constants.RENATIVE_CONFIG_NAME),JSON.stringify(c.buildConfig,null,2));


var fontsObj='export default [';

if(c.buildConfig){
if(!c.buildConfig.common){
reject("Your "+_chalk.default.white(c.paths.appConfig.config)+" is missconfigured. (Maybe you have older version?). Missing "+_chalk.default.white('{ common: {} }')+" object at root");
return;
}
if(_fs.default.existsSync(c.paths.project.projectConfig.fontsDir)){
_fs.default.readdirSync(c.paths.project.projectConfig.fontsDir).forEach(function(font){
if(font.includes('.ttf')||font.includes('.otf')){
var key=font.split('.')[0];var
includedFonts=c.buildConfig.common.includedFonts;
if(includedFonts){
if(includedFonts.includes('*')||includedFonts.includes(key)){
if(font){
var fontSource=_path.default.join(c.paths.project.projectConfig.dir,'fonts',font);
if(_fs.default.existsSync(fontSource)){




fontsObj+="{\n                                            fontFamily: '"+
key+"',\n                                            file: require('../../projectConfig/fonts/"+
font+"'),\n                                        },";

}else{
(0,_logger.logWarning)("Font "+_chalk.default.white(fontSource)+" doesn't exist! Skipping.");
}
}
}
}
}
});
}
}

fontsObj+='];';
_fs.default.writeFileSync(_path.default.join(c.paths.project.assets.dir,'runtime','fonts.js'),fontsObj);
var supportFiles=_path.default.resolve(c.paths.rnv.dir,'supportFiles');
(0,_fileutils.copyFileSync)(
_path.default.resolve(supportFiles,'fontManager.js'),
_path.default.resolve(c.paths.project.assets.dir,'runtime','fontManager.js'));

(0,_fileutils.copyFileSync)(
_path.default.resolve(supportFiles,'fontManager.web.js'),
_path.default.resolve(c.paths.project.assets.dir,'runtime','fontManager.web.js'));


resolve();
});};exports.copyRuntimeAssets=copyRuntimeAssets;


var copySharedPlatforms=function copySharedPlatforms(c){return new Promise(function(resolve){
(0,_logger.logTask)("_copySharedPlatform:"+c.platform);

if(c.platform){
(0,_fileutils.mkdirSync)(_path.default.resolve(c.paths.project.platformTemplatesDirs[c.platform],'_shared'));

(0,_fileutils.copyFolderContentsRecursiveSync)(
_path.default.resolve(c.paths.project.platformTemplatesDirs[c.platform],'_shared'),
_path.default.resolve(c.paths.project.builds.dir,'_shared'));

}

resolve();
});};exports.copySharedPlatforms=copySharedPlatforms;